# Copyright 1999-2014. Parallels IP Holdings GmbH. All Rights Reserved.
# -*- coding: utf-8; mode: python -*-
"""This module contains various classes and functions to ease display
and otherwise represent various aspects of PAM Configurations"""

def printConf(chain, facility = None, service = None):
    """pretty prints the PAM configuration chain returned by getConf"""
    if service:
        print service, 
        if facility:
            print ",", facility,
        # endif
        print ":"
    # endif

    # first collect data to display. This approach allows us to count
    # alignments etc. generally it's not that memory hog for a typical
    # PAM configuration
    result = map(lambda (a, c, i): (a.control, a.module,
                                    ' '.join(a.module_args), c.service, i),
                 chain)

    title = ('imp.', 'modname', 'modargs', 'service', '# of atom')

    l = lambda i: reduce(max, map(lambda t: len(str(t[i])), result), len(title[i]))
    # iterate over first 4 columns
    lens = map(l, xrange(4))
    # lens now contains maximal columns lengths.

    # prepare format string
    fmt = '%%%ds | %%%ds | %%%ds | %%%ds | %%s' % tuple(lens)

    # form title
    titlestr = fmt % (title)

    # print title
    print titlestr

    # print a divider
    print '-' * len(titlestr)

    # print result content
    for r in result:
        print fmt % tuple(r)

    # print a divider
    print '-' * len(titlestr)

    # print an empty line
    print

    return None
# enddef printConf
